
#include "stdafx.h"
#include "AsdTool.h"

bool CAsdTool::Check( const char* fname, unsigned long fsize )
{
	const unsigned char* hdr = CTool::common_buf;
	unsigned long siz = (fsize>XACR_BUFSIZE ? XACR_BUFSIZE : fsize);
//--------------------------------------------------------------------//

	// @̐ A S D 0 1 [1a] !
	return ( siz>6 && hdr[0]=='A' && hdr[1]=='S' && hdr[2]=='D'
		&& hdr[3]=='0' && hdr[4]=='1' && hdr[5]==0x1A );
}

bool CAsdTool::Extract( const char* fname,const char* ddir )
{
	unsigned char buf[300];
//--------------------------------------------------------------------//

	// J
	FILE* asd = fopen( fname, "rb" );
	if( !asd ) return false;

	// }WbNioƂ΂
	fseek( asd, 6, SEEK_CUR );

	// i[Ăt@C
	if( 2!=fread( buf, 1, 2, asd ) )
	{
		fclose( asd );
		return false;
	}
	int num_of_files = (buf[0]) + (buf[1]<<8);

	// wb_̊Jnʒu
	// iwb_ʂ̃Ɋi[͖̂炩Aj
	// iʓ|Ȃ̂(^^;ASEEK܂ŉBj
	long header_pos = 8;

	// kꂽf[^̊Jnʒu
	for( int t,d=0; d!=num_of_files; d++ )
		if( EOF == (t=fgetc(asd))
		 || (t+14) != (signed)fread( buf, 1, (t+14), asd ) )
		{
			fclose( asd );
			return false;
		}
	init_expander( fgetc( asd ) );
	long data_pos = ftell( asd );

	// WJJn
	for( int c,i=0; i!=num_of_files; i++ )
	{
		// ̃t@C̏i[ʒu
		fseek( asd, header_pos, SEEK_SET );

		// wb_
		c = fgetc(asd);
		fread( buf, 1, c+14, asd );

		char outname[256];		// t@C
		memcpy( outname, buf, c ), outname[c] = '\0';
		unsigned long orisize =	// TCY
			(buf[c+ 0])+(buf[c+ 1]<<8)+(buf[c+ 2]<<16)+(buf[c+ 3]<<24);
		unsigned long cr =		// CRC
			(buf[c+ 4])+(buf[c+ 5]<<8)+(buf[c+ 6]<<16)+(buf[c+ 7]<<24);
		unsigned long uptime =	// XV
			(buf[c+ 8])+(buf[c+ 9]<<8)+(buf[c+10]<<16)+(buf[c+11]<<24);
		unsigned short attr =	// 
			(buf[c+12])+(buf[c+13]<<8);

		// wb_ʒu|C^i߂Ă
		header_pos += (1+c+14);

		// o͐t@CJ
		char* cn = kiutil::pathMake( outname );
		FILE* out = fopen( cn, "wb" );

		// WJ
		fseek( asd, data_pos, SEEK_SET );
		bool eof = expand_data( asd, out, orisize );
		data_pos = ftell( asd );

		// đݒiʓ|Ȃ̂CRC`FbNj
		if( out )
		{
			fclose( out );
			kiutil::timeSet( cn, (unsigned short)(uptime>>16),
								 (unsigned short)(uptime&0xffff) );
			SetFileAttributes( cn, attr );
		}

		if( eof )
			break;
	}

	fclose( asd );
	return true;
}

void CAsdTool::init_expander( int x )
{
	// LZSS[`
	wptr = xptr = 0;
	memset( CTool::common_buf, 0, 4096 );
	verylong = (x&0xff);
}

#define incr(x) (x=(x+1)&0xfff)
bool CAsdTool::expand_data( FILE* in, FILE* out, unsigned long len )
{
	unsigned char* buf = CTool::common_buf;
//--------------------------------------------------------------------//

	while( len )
	{
		// obt@ɎcĂ镨o
		while( len && wptr != xptr )
		{
			if( out )
				fputc( buf[wptr], out );
			incr( wptr ), len--;
		}
		if( len==0 )
			return false;
		if( feof(in) )
			return true;

		// WJBTCY4096bytes  LZSSB
		unsigned char flag = fgetc(in);
		for( int sft=8; sft; sft-- )
		{
			if( flag & (1<<(sft-1)) )
			{
				// bit-ONꂽf[^
				unsigned short code = (fgetc(in)<<8)+fgetc(in);
				int fptr = (xptr-1-(code&0xfff))&0xfff;
				int ln = (code>>12)+3;
				if( ln==18 )
					ln += verylong;

				while( ln-- )
				{
					buf[xptr] = buf[fptr];
					incr(xptr), incr(fptr);
				}
			}
			else
			{
				// bit-OFFf̂܂
				buf[xptr] = fgetc(in);
				incr(xptr);
			}
		}
	}

	return false;
}
#undef incr
